Subject: [bug#39729] [PATCH 0/7] Testing the graphical installer

From: Ludovic Courtès <[email-masked]>
Date: Thu, 05 Mar 2020 23:46:27 +0100

Hi Mathieu!

Mathieu Othacehe <[email-masked]> skribis:

>> The second part implements the actual test.  The new (gnu installer
>> tests) module provides tools to implement a dialogue with the installer,
>> and the new “gui-installed-os” test uses it to perform a bare-bones
>> style installation.  There’s a commented out variant that does it on
>> an encrypted root, but it currently fails presumably due to
>> <https://issues.guix.gnu.org/issue/39712>.
>>
>> That’s it!
>>
>> Feedback welcome!
>
> This serie LGTM, this is really impressive :) About the umounting issue,
> you were right. Umounting failed for both %test-gui-installed-os and
> %test-gui-installed-os-encrypted.
>
> The issue was that guix-daemon was keeping open files inside the
> cow-store, preventing the umount. I discovered then a second issue, some
> udevd workers, started while the cow-store was active were also
> preventing the umounting.
>
> I published a few patches on top of yours on wip-installer-test to fix
> those issues.

Well done, woohoo!

I’ve pushed the whole series on ‘master’, including your bug fixes.

We can think about writing installer tests for other configurations
now.  That should be the easy part.  :-)

> PS: I had a hard time debugging the marionette, couldn't find better to
> add some syslog, wait an hour to test & repeat. Do you have a better
> approach? Would it be possible to have a debug ssh in the marionette?

I don’t really have a better approach.  If you want to see the output of
‘guix system init’, you can redirect its stderr to /dev/console (wrap
the ‘invoke’ call in ‘with-error-to-file’), and then you get a better
idea of what’s going on.  But that’s about it.

SSH wouldn’t be very helpful because the test process is non-interactive.

Thanks!

Ludo’.